# holoseit 0.0004b4 by Tokigun (2004.10.16)
# http://studio.tokigun.net/py/holoseit/
# very buggy, only for test purposes
# 
# vim: columns=120

import psyco
psyco.full()

import pygame, Numeric, win32gui
from pygame.locals import *
import time, sys, os, os.path, random, bisect, struct

def merge(self, other):
	if len(self) > len(other):
		for x in xrange(len(other)):
			if other[x]: self[x] = other[x]
	else:
		for x in xrange(len(self)):
			if other[x]: self[x] = other[x]
		for x in xrange(len(self), len(other)):
			self.append(other[x])

def ffloat(str):
	num = str.replace(str.lstrip('0123456789. '), '')
	return num and float(num) or 0.0

def fint(str):
	num = str.replace(str.lstrip('0123456789- '), '')
	return num and int(num) or 0

indexkey = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
def indexhash(index):
	if index == None: return 0
	return indexkey.find(index[0].upper()) * 36 + indexkey.find(index[1].upper()) + 1

def get_pygamever():
	return map(fint, pygame.__version__.split('.'))

def SoundPart(sound, pos):
	return pygame.sndarray.make_sound(
		pygame.sndarray.array(sound)[int(pygame.mixer.get_init()[0] * pos):])

################################################################################
# win32 specific functions

if sys.platform == 'win32':
	def str2ptr(str):
		# typedef struct {
		#     struct _object *_ob_next;
		#     struct _object *_ob_prev;
		#     int ob_refcnt;       // offset 0x00 in win32
		#     struct _typeobject *_ob_type;
		#     int ob_size;
		#     long ob_shash;
		#     int ob_sstate;
		#     char ob_sval[1];     // offset 0x1c in win32
		# } PyStringObject;
		
		return id(str) + 20
	
	def GetOpenFileName(title, filter, initdir=None):
		_filter = '\0'.join([p[0]+'\0'+p[1] for p in filter]) + '\0\0'
		filename = '\0' * 512
		if not initdir: initdir = os.path.realpath(os.getcwd())
		if initdir[-1] != os.sep: initdir += os.sep
		pstruct = struct.pack('IIIIIIIIIIIIIIHHIIII',
			76, 0, 0, str2ptr(_filter), 0, 0, 0, str2ptr(filename), 512, 0, 0,
			str2ptr(initdir), str2ptr(title), 0, 0, 0, 0, 0, 0, 0)
		win32gui.GetOpenFileName(pstruct)
		return filename[:filename.find('\0')]
	
	def MessageBox(caption, title):
		win32gui.MessageBox(None, caption, title, 0)
	
else:
	def GetOpenFileName(title, filter):
		return ""
	
	def MessageBox(caption, title):
		print '%s:\n%s' % (title, caption)

################################################################################

class BMSNote(object):
	__slots__ = [
		'sound', 'layer', 'poorimg', 'bpm', 'stop',
		'player1', 'player1inv', 'player2', 'player2inv'
	]
	
	def __init__(self):
		self.layer = []
		self.poorimg = 0
		self.bpm = 0.0
		self.stop = 0
		self.clear()
	
	def set(self, name, value):
		if isinstance(name, str):
			setattr(self, name, value)
		elif len(getattr(self, name[0])) > name[1]:
			getattr(self, name[0])[name[1]] = value
		else:
			temp = getattr(self, name[0])
			temp += [0] * (name[1] - len(getattr(self, name[0]))) + [value]
	
	def update(self, obj):
		self.sound += obj.sound
		merge(self.layer, obj.layer)
		self.poorimg = obj.poorimg
		self.bpm = obj.bpm
		self.stop = obj.stop
		merge(self.player1, obj.player1)
		merge(self.player2, obj.player2)
		merge(self.player1inv, obj.player1inv)
		merge(self.player2inv, obj.player2inv)
	
	def clone(self):
		obj = BMSNote()
		obj.sound = self.sound[:]
		obj.layer = self.layer[:]
		obj.poorimg = self.poorimg
		obj.bpm = self.bpm
		obj.stop = self.stop
		obj.player1 = self.player1[:]
		obj.player1inv = self.player1inv[:]
		obj.player2 = self.player2[:]
		obj.player2inv = self.player2inv[:]
		return obj
	
	def clear(self):
		self.sound = []
		self.player1 = [0] * 9
		self.player1inv = [0] * 9
		self.player2 = [0] * 9
		self.player2inv = [0] * 9

################################################################################

class BMS:
	__idxstep = 100
	
	def __init__(self, filename):
		self.basepath, self.filename = os.path.split(filename)
		self.basepath += os.sep
		self.load(file(filename, "r"))
		self.make_index()
	
	def __getitem__(self, index):
		if not isinstance(index, tuple):
			return self.sequence[index]
		
		try:
			self.sequence[index[0]]
		except:
			self.sequence[index[0]] = BMSNote()
		
		if len(index) == 2:
			return getattr(self.sequence[index[0]], index[1])
		elif len(index) == 3:
			return getattr(self.sequence[index[0]], index[1])[index[2]]
		else:
			raise IndexError
	
	def __setitem__(self, index, value):
		if not isinstance(index, tuple):
			self.sequence[index] = value
			return
		
		try:
			self.sequence[index[0]]
		except:
			self.sequence[index[0]] = BMSNote()
		
		if len(index) == 2:
			self.sequence[index[0]].set(index[1], value)
		elif len(index) == 3:
			self.sequence[index[0]].set(index[1:], value)
		else:
			raise IndexError
	
	def load(self, fp):
		self.bpm = 130
		self.sndres = {}
		self.imgres = {}
		self.sequence = {}
		self.index = {}
		
		fp.seek(0)
		dice = 1
		ignored = False
		longnote = 0
		for line in fp:
			uline = line.upper()
			if uline.strip() == '#ENDIF':
				ignored = False
			elif ignored:
				pass
			elif uline.startswith('#TITLE '):
				self.title = line[7:].strip()
			elif uline.startswith('#ARTIST '):
				self.artist = line[8:].strip()
			elif uline.startswith('#BPM '):
				self.bpm = ffloat(line[5:])
			elif uline.startswith('#VOLWAV '):
				self.volume = fint(line[8:]) / 100.
			elif uline.startswith('#WAV'):
				self.sndres[indexhash(line[4:6])] = line[7:].strip()
			elif uline.startswith('#BMP'):
				self.imgres[indexhash(line[4:6])] = line[7:].strip()
			elif uline.startswith('#BGA'):
				temp = line[7:].strip().split()
				temp = [indexhash(temp[0])] + map(fint, temp[1:])
				temp[1:5] = map(lambda x:x>256 and 256 or x>0 and x or 0, temp[1:5])
				self.imgres[indexhash(line[4:6])] = \
					(temp[0], (temp[5], temp[6]), (temp[1], temp[2], temp[3]-temp[1], temp[4]-temp[2]))
			elif uline.startswith('#STAGEFILE '):
				self.imgres['title'] = line[11:].strip()
			elif uline.startswith('#BPM'):
				pass # extended bpm message is not implemented
			elif uline.startswith('#STOP'):
				pass # stop sequence message is not implemented
			elif uline.startswith('#CDDA '):
				pass # cdda is not supported
			elif uline.startswith('#BACKBMP '):
				pass # background graphic is not implemented
			elif uline.startswith('#LNTYPE '):
				longnote = fint(line[8:])
			elif uline.startswith('#LNOBJ '):
				longnote = -1
				longnoteobj = indexhash(line[7:9])
			elif uline.startswith('#MIDIFILE '):
				pass # midi is not supported
			elif uline.startswith('#RANDOM '):
				dice = random.randint(1, fint(line[8:]))
			elif uline.startswith('#IF '):
				if fint(line[4:]) == dice:
					ignored = False
				else:
					ignored = True
			elif line[0] == '#' and line[1:6].isdigit() and line[6] == ':':
				track, channel, rawdata, data = \
					int(line[1:4]), int(line[4:6]), line[7:].strip(), []
				for x in xrange(len(rawdata)/2):
					data.append(rawdata[x*2:x*2+2])
				length = float(len(data))
				
				# 01:bgm 02:shorten_measure 03:bpm 04:bga
				# 06:poorbga 07:bgalayer 08:extbpm 09:stop
				# x1-x5:1-5keys x6:scratch x7:pedal x8-x9:6-7keys
				# 1x,2x:visibleobj 3x,4x:invisibleobj 5x,6x:longnote
				
				if channel == 1:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'sound'].append(indexhash(data[x]))
				elif channel == 2:
					pass # shortening note is not implemented
				elif channel == 3:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'bpm'] = int(data[x], 16)
				elif channel == 4:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'layer', 0] = indexhash(data[x])
				elif channel == 6:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'poorimg'] = indexhash(data[x])
				elif channel == 7:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'layer', 1] = indexhash(data[x])
				elif channel == 8:
					pass # extended bpm is not implemented
				elif channel == 9:
					pass # stop sequence is not implemented
				elif 11 <= channel <= 19:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'player1', channel-11] = indexhash(data[x])
				elif 21 <= channel <= 29:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'player2', channel-21] = indexhash(data[x])
				elif 31 <= channel <= 39:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'player1inv', channel-31] = indexhash(data[x])
				elif 41 <= channel <= 49:
					for x in xrange(int(length)):
						if data[x] != '00':
							self[track+x/length, 'player2inv', channel-41] = indexhash(data[x])
#				elif 51 <= channel <= 59:
#					for x in xrange(int(length)):
#						if data[x] != '00':
#							self[track+x/length, 'player1', channel-51] = -indexhash(data[x])
#				elif 61 <= channel <= 69:
#					for x in xrange(int(length)):
#						if data[x] != '00':
#							self[track+x/length, 'player2', channel-61] = -indexhash(data[x])
		
		self.seqindex = self.sequence.keys()
		self.seqindex.sort()
		self.length = self.seqindex[-1]
	
	def make_index(self):
		current = BMSNote()
		current.bpm = self.bpm
		for pos in xrange(len(self.seqindex)):
			current.update(self.sequence[self.seqindex[pos]])
			if pos % self.__idxstep == 0:
				current.clear()
				self.index[pos] = current.clone()
				print "sequence indexing... %d of %d" % (pos, len(self.seqindex))
		current.clear()
		self.index[self.seqindex[-1]] = current.clone()
	
	def rewind(self):
		self.position = -1
		self.stopped = False
		self.read(-1)
	
	def read(self, position):
		if position > self.length:
			self.stopped = True
			return self.index[self.seqindex[-1]]
		
		tposition = bisect.bisect(self.seqindex, position) - 1
		if tposition < 0:
			self.position = -1
			self.current = BMSNote()
			self.current.bpm = self.bpm
			return self.current
		elif 0 <= tposition - self.position < self.__idxstep:
			nposition = self.position
		else:
			nposition = tposition - tposition % self.__idxstep
			self.current = self.sequence[self.seqindex[nposition]].clone()
		self.position = tposition
		
		self.current.clear()
		while nposition < tposition:
			nposition += 1
			self.current.update(self.sequence[self.seqindex[nposition]])
		return self.current

################################################################################

class BMSPlayer:
	__version__ = "0.0004b4"
	__idxstep = 100
	
	def __init__(self, approot):
		self._double = False
		self._window = 0
		self._loop = False
		self._status = -1
		self._pstatus = -1
		self._volume = 1.0
		self._x_sound = True
		self._x_screen = True
		self._x_note = False
		self._pygameext = (get_pygamever() >= [1, 6, 2])
		
		self.p_title = ''
		self.p_status = 'holoseit %s by Tokigun' % self.__version__
		
		pygame.mixer.init()
		if self._pygameext:
			pygame.mixer.set_num_channels(64)
		self.nsamples = pygame.mixer.get_init()[0]
		pygame.font.init()
		self.font = pygame.font.Font(approot + 'console.ttf', 12)
		self.update_display()
		
		self.bms = None
		self.clock = pygame.time.Clock()
		self.resource = pygame.image.load(approot + 'resource.png').convert()
		self.resource.set_colorkey((0, 0, 0), RLEACCEL)
	
	def update_display(self):
		h_header = h_footer = 16
		h_screen = w_screen = self._double and 512 or 256
		w_note = self._x_note and 50 or 0
		w_window = 0
		self.w_surround = w_note + w_screen
		
		self.realscreen = pygame.display.set_mode(
			(w_note + w_screen + w_window, h_header + h_screen + h_footer))
		self.screen = self.realscreen.subsurface(w_note, h_header, w_screen, h_screen)
		self.tempscreen = self._double and self.realscreen.subsurface(w_note, h_header, 256, 256) or self.screen
		self.topbar = self.realscreen.subsurface(0, 0, w_note + w_screen, h_header)
		self.bottombar = self.realscreen.subsurface(0, h_header + h_screen, w_note + w_screen, h_footer)
		self.notewin = w_note and self.realscreen.subsurface(0, h_header, w_note, h_screen) or None
		self.infowin = w_window and self.realscreen.subsurface(w_note + w_screen, 0, w_window, h_header + h_screen + h_footer) or None
		
		self.realscreen.fill((64, 64, 64))
		self.screen.fill((0, 0, 0))
		self.set_title(self.p_title)
		self.set_status(self.p_status)
		pygame.display.flip()
	
	def set_title(self, str):
		self.p_title = str
		if str:
			pygame.display.set_caption('%s - holoseit %s' % (str, self.__version__))
		else:
			pygame.display.set_caption('holoseit %s' % self.__version__)
	
	def set_status(self, str):
		self.p_status = str
		self.bottombar.blit(self.font.render(str, True, (255, 255, 255)), (2, 2))
	
	def load(self, bms):
		self.bms = bms
		
		print "loading image resources...",
		self.imgres = {}
		for key, value in self.bms.imgres.iteritems():
			try:
				if isinstance(value, tuple):
					self.imgres[key] = ()
				else:
					self.imgres[key] = pygame.image.load(self.bms.basepath + value).convert()
					self.imgres[key].set_colorkey((0, 0, 0), RLEACCEL)
			except:
				self.imgres[key] = None
		print "done."
		
		print "loading sound resources...",
		self.sndres = {}
		for key, value in self.bms.sndres.iteritems():
			try:
				self.sndres[key] = pygame.mixer.Sound(self.bms.basepath + value)
			except:
				self.sndres[key] = None
		print "done."
		
		self.analyse_sndres()
	
	def analyse_sndres(self):
		self.sndlen = {}
		if self._pygameext:
			for key, value in self.sndres.iteritems():
				self.sndlen[key] = value and value.get_length() or 0.0
		else:
			for key, value in self.sndres.iteritems():
				self.sndlen[key] = value and len(pygame.sndarray.array(value)) * self.insamples or 0.0
		
		self.sndindex = {}
		sndtable = []
		ppos = 0.0
		length = 0.0
		for pos in xrange(len(self.bms.seqindex) / self.__idxstep * self.__idxstep + 1):
			note = self.bms.sequence[self.bms.seqindex[pos]]
			rpos = self.bms.seqindex[pos] * 240. / self.bms.bpm
			sndtable = [(p[0], p[1]-rpos+ppos) for p in sndtable if p[1]+ppos > rpos]
			for y in note.sound + note.player1 + note.player1inv:
				try:
					if y:
						sndtable.append((y, self.sndlen[y]))
						if length < rpos + self.sndlen[y]:
							length = rpos + self.sndlen[y]
				except:
					pass
			if pos % self.__idxstep == 0:
				self.sndindex[pos] = sndtable[:]
				print "soundpart indexing... %d of %d" % (pos, len(self.bms.seqindex))
			ppos = rpos
		self.length = length
	
	def play_sndpart(self, pos):
		tpos = bisect.bisect(self.bms.seqindex, pos / 240. * self.bms.bpm) - 1
		ipos = tpos / self.__idxstep * self.__idxstep
		if ipos < 0: ipos = 0
		sndtable = self.sndindex[ipos][:]
		ppos = 0.0
		while ipos < tpos:
			ipos += 1
			note = self.bms.sequence[self.bms.seqindex[ipos]]
			diff = (self.bms.seqindex[ipos] - self.bms.seqindex[ipos-1]) * 240. / self.bms.bpm
			sndtable = [(p[0], p[1]-diff) for p in sndtable if p[1] > diff]
			for y in note.sound + note.player1 + note.player1inv:
				if y: sndtable.append((y, self.sndlen.get(y, 0)))
		
		dpos = pos - self.bms.seqindex[tpos] * 240. / self.bms.bpm
		for sndid, sndpos in sndtable:
			if sndpos > dpos:
				SoundPart(self.sndres[sndid], self.sndlen[sndid] - sndpos + dpos).play()
	
	def update_status(self, count):
		self.topbar.fill((64, 64, 64))
		self.topbar.blit(self.resource, (2, 2), (self._status*12, 0, 12, 12))
		self.topbar.blit(self.resource, (16, 2), (self._loop and 60 or 48, 0, 12, 12))
		surf = self.font.render("%s%d:%02d.%d / %d:%02d.%d" %
			(self._double and "[2x] " or "", count//60, int(count)%60, int(count*10)%10,
			 self.length//60, int(self.length)%60, int(self.length*10)%10),
			True, (255, 255, 255))
		self.topbar.blit(surf, (30, 2))
		
		surf = self.font.render(self.bms.filename, True, (255, 255, 255))
		self.topbar.blit(surf, (self.w_surround - surf.get_width() - 2, 2))
	
	def eventhandler(self):
		while True:
			event = pygame.event.poll()
			if event.type == NOEVENT:
				return ("none",)
			#elif event.type == QUIT:
			#	return ("exit",)
			elif event.type == KEYDOWN:
				if event.key == K_ESCAPE:
					return ("exit",)
				elif event.key == K_SPACE:
					return ("pause",)
				elif event.key == K_F1:
					return ("view_help",)
				elif event.key == K_F2:
					return ("toggle_double",)
				elif event.key == K_F3:
					return ("toggle_loop",)
				elif event.key == K_F4:
					return ("toggle_note",)
				elif event.key == K_F10:
					return ("toggle_info",)
				elif event.key == K_LEFT or event.key == K_RIGHT:
					return ("seek",
						(event.mod & KMOD_SHIFT and 60 or 10) *
						(event.key == K_LEFT and -1 or 1))
				elif event.key == K_HOME:
					return ("absseek", 0)
				elif event.key == K_UP or event.key == K_DOWN:
					return ("volume", event.key == K_UP and 0.1 or -0.1)
				elif event.key == K_DELETE:
					return ("toggle_sound",)
				elif event.key == K_INSERT:
					return ("toggle_screen",)
			elif event.type == KEYUP:
				if event.key == K_LEFT or event.key == K_RIGHT:
					return ("endseek",)
	
	def blit_imgres(self, id):
		if self.imgres[id] == ():
			data = self.bms.imgres[id]
			self.tempscreen.blit(self.imgres[data[0]], data[1], data[2])
		elif self.imgres[id]:
			self.tempscreen.blit(self.imgres[id], (0, 0))
	
	def play(self):
		measurelen = 240. / self.bms.bpm
		if self._status < 0:
			self._status = 2
		
		self.set_title('%s / %s' % (self.bms.title, self.bms.artist))
		self.set_status('holoseit %s by Tokigun' % self.__version__)
		
		stime = time.time()
		ptime = 0
		_prevstatus = self._status
		event = ('none',)
		self.bms.rewind()
		pygame.mixer.stop()
		while time.time() - stime < self.length:
			utime = time.time()
			if not self.bms.stopped and self._status != 1:
				ntime = (utime - stime) / measurelen
				current = self.bms.read(ntime)
				if self._status != 2 or _prevstatus != 2:
					current.clear()
				self.screen.fill((0, 0, 0))
				if self._x_sound:
					for sndid in current.sound + current.player1 + current.player1inv:
						if sndid and self.sndres[sndid]:
							self.sndres[sndid].play()
				if self._x_screen:
					for imgid in current.layer:
						if imgid and self.imgres[imgid]:
							self.blit_imgres(imgid)
					if self._double:
						self.screen.blit(pygame.transform.scale(self.tempscreen, (512, 512)), (0, 0))
			
			_prevstatus = self._status
			if self._status == 1 or self._pstatus == 1:
				self.update_status(ptime)
			else:
				self.update_status(utime - stime)
			
			event = self.eventhandler()
			if event[0] == 'exit':
				return False
			elif event[0] == 'seek':
				self._pstatus = self._status
				self._status = 3
				self._status_dtime = event[1]
				pygame.mixer.stop()
				self.bms.stopped = False
			elif event[0] == 'absseek':
				pygame.mixer.stop()
				stime = utime - event[1]
			elif event[0] == 'endseek':
				self._status = self._pstatus
				self._pstatus = -1
				self.play_sndpart(utime - stime)
			elif event[0] == 'pause':
				if self._status == 2:
					ptime = utime - stime
					self._status = 1
					pygame.mixer.stop()
				else:
					stime = utime - ptime
					self._status = 2
					self.play_sndpart(ptime)
			elif event[0] == 'toggle_double':
				self._double = not self._double
				self.update_display()
			elif event[0] == 'toggle_loop':
				self._loop = not self._loop
			elif event[0] == 'toggle_sound':
				pygame.mixer.stop()
				self._x_sound = not self._x_sound
			elif event[0] == 'toggle_screen':
				self.screen.fill((0, 0, 0))
				self._x_screen = not self._x_screen
			
			if self._status == 3:
				stime -= self._status_dtime
				if stime > utime:
					stime = utime
				if self._pstatus == 1:
					ptime = utime - stime
			
			pygame.display.flip()
			self.clock.tick(self._status==2 and 96 or 6)
		
		return True

################################################################################

def using():
	print "holoseit version %s by Tokigun (tokigun@gmail.com)" % BMSPlayer.__version__
	print "http://studio.tokigun.net/py/holoseit/"
	print
	print "Using: holoseit <bms file>"

def main(argv):
	approot = os.path.split(os.path.realpath(argv[0]))[0] + os.sep
	if len(argv) != 2:
		filename = GetOpenFileName('Choose a file to play', (
			('All Be-Music Source File (*.bms;*.bme;*.bml)', '*.bms;*.bme;*.bml'),
			('Be-Music Source File (*.bms)', '*.bms'),
			('Extended Be-Music Source File (*.bme)', '*.bme'),
			('Longnote-support Be-Music Source File (*.bml)', '*.bml'),
			('All Files (*.*)', '*.*')))
		if filename == '':
			using()
			return
	else:
		filename = argv[1]
	
	try:
		bms = BMS(os.path.realpath(filename))
	except IOError:
		MessageBox('File Not Found: %s' % filename, 'holoseit error message')
		return
	
	player = BMSPlayer(approot)
	player.load(bms)
	while player.play() and player._loop: pass

if __name__ == '__main__':
	import sys
	main(sys.argv)

print 3

